"use strict";
// reference:
//  https://stackoverflow.com/questions/18638900/javascript-crc32
//  https://stackoverflow.com/questions/32940417/unsigned-crc-32-for-python-to-match-javas-crc-32
Object.defineProperty(exports, "__esModule", { value: true });
exports.unsigned = exports.crc32 = void 0;
// export function unsigned(str: string) {
//   return signed(str) & 0xffffffff;
// }
function makeCRCTable() {
    let c;
    const crcTable = [];
    for (let n = 0; n < 256; n++) {
        c = n;
        for (let k = 0; k < 8; k++) {
            c = c & 1 ? 0xedb88320 ^ (c >>> 1) : c >>> 1;
        }
        crcTable[n] = c;
    }
    return crcTable;
}
let T;
function crc32(str) {
    const crcTable = T || (T = makeCRCTable());
    let crc = 0 ^ -1;
    for (let i = 0; i < str.length; i++) {
        crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xff];
    }
    return (crc ^ -1) >>> 0;
}
exports.crc32 = crc32;
exports.unsigned = crc32;
